summaryrefslogtreecommitdiff
path: root/t
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-04-23 22:56:52 +0200
committerStefano Lattarini <stefano.lattarini@gmail.com>2012-04-23 23:10:44 +0200
commitf450cd19f4efa6ab3bafa072d7756239b6888ae0 (patch)
tree189b97303884e46c71512b002380753ac9ed27b1 /t
parent509b231118fff35e8f5dbfa797218265e8bc6acc (diff)
downloadautomake-f450cd19f4efa6ab3bafa072d7756239b6888ae0.tar.gz
coverage: test the internal $(am__relativize) variable
This new coverage might turn out be useful for the planned changes in Automake-NG. Even if it eventually doesn't, we gen an improved testsuite exposure of some non-trivial internals, so it's always a win for us. * t/relativize.tap: New test. * t/list-of-tests.mk: Add it. Signed-off-by: Stefano Lattarini <stefano.lattarini@gmail.com>
Diffstat (limited to 't')
-rw-r--r--t/list-of-tests.mk1
-rwxr-xr-xt/relativize.tap96
2 files changed, 97 insertions, 0 deletions
diff --git a/t/list-of-tests.mk b/t/list-of-tests.mk
index 2a3ec3507..fef716517 100644
--- a/t/list-of-tests.mk
+++ b/t/list-of-tests.mk
@@ -885,6 +885,7 @@ t/python-virtualenv.sh \
t/python-pr10995.sh \
t/recurs.sh \
t/recurs2.sh \
+t/relativize.tap \
t/remake.sh \
t/remake1a.sh \
t/remake2.sh \
diff --git a/t/relativize.tap b/t/relativize.tap
new file mode 100755
index 000000000..8f53b6ce3
--- /dev/null
+++ b/t/relativize.tap
@@ -0,0 +1,96 @@
+#! /bin/sh
+# Copyright (C) 2012 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# Test Automake-provided internal make macro $(am__relativize).
+
+am_create_testdir=empty
+. ./defs || Exit 1
+
+plan_ later
+
+mkdir uber uber/top
+cd uber/top
+
+: > install-sh
+: > missing
+
+cat >> configure.ac <<END
+AC_INIT([$me], [1.0])
+AM_INIT_AUTOMAKE
+AC_CONFIG_FILES([Makefile])
+AC_OUTPUT
+END
+
+cat > Makefile.am << 'END'
+# The 'am__relitivize' definition is only brought in when
+# SUBDIRS are defined.
+SUBDIRS = .
+
+.PHONY: test
+test:
+ @$(am__relativize); echo "result: '$$reldir'"; set -x; \
+ case $${reldir:-.} in "$$exp"|"$$exp/.") ;; *) exit 1;; esac
+END
+
+$ACLOCAL && $AUTOMAKE && $AUTOCONF && ./configure || fatal_ "setup failure"
+
+rel_ ()
+{
+ case $1 in -x) directive=TODO; shift;; *) directive=;; esac
+ test $# -eq 4 && test x"$3" = x"=" || fatal_ "rel_: incorrect usage"
+ command_ok_ "$1/{$4} = $2" -D "$directive" \
+ env dir1=$1 dir2=$2 exp=$4 $MAKE test
+}
+
+# am__relativize
+# ~~~~~~~~~~~~~~
+# Computes a relative pathname RELDIR such that DIR1/RELDIR = DIR2.
+# Input:
+# - DIR1 relative pathname, relative to the current directory
+# - DIR2 relative pathname, relative to the current directory
+# Output:
+# - reldir relative pathname of DIR2, relative to DIR1
+
+rel_ . . = .
+rel_ . .. = ..
+rel_ .. . = top
+
+for d in x long-longer a/b 1/2/3/4/5; do
+ rel_ $d $d = .
+ for d2 in . .. x r/s/t; do
+ rel_ $d $d/$d2 = $d2
+ done
+done
+
+rel_ one two = ../two
+rel_ a b/c = ../b/c
+rel_ a/b . = ../..
+rel_ a/b foo = ../../foo
+rel_ a/b foo/bar = ../../foo/bar
+rel_ a/b a/c = ../c
+rel_ a/b a/c/d = ../c/d
+
+rel_ foo/bar/baz foo/bar/qux/zap = ../qux/zap
+
+rel_ ../foo . = ../top
+rel_ ../.. . = uber/top
+rel_ ../../foo . = ../uber/top
+rel_ ../../x ok = ../uber/top/ok
+rel_ ../../x bo/ba = ../uber/top/bo/ba
+rel_ ../../x ../ok2 = ../uber/top/../ok2
+rel_ ../a/b/c/d/e . = ../../../../../top
+
+: